# Author: Kapil Thangavelu <kvthan@wm.edu>
# License: GPL
# CVS: $Id: ExtSearch.py,v 1.2 2001/09/29 23:29:48 ender Exp $

from SwishSearch import swish_search
from string import join, split

from Globals import DTMLFile, InitializeClass
from AccessControl import ClassSecurityInfo 
from OFS.SimpleItem import SimpleItem
from Acquisition import Implicit
from OFS.PropertyManager import PropertyManager

from string import atoi

def manage_addExtSearch(self, id, title='', host='localhost', port=1967,
                pathswap=None, REQUEST=None):
    """ """

    ob = ExtSearch(id, title, host, port, pathswap)
    self._setObject(id, ob)
    
    if REQUEST:
        REQUEST.RESPONSE.redirect(REQUEST['URL1']+'/manage_main')
        
manage_addExtSearchForm = DTMLFile('dtml/manage_addExtSearchForm', globals())
        

class ExtSearch(SimpleItem, PropertyManager, Implicit):

    meta_type = 'ExtSearch'
        
    security = ClassSecurityInfo()
    
    manage_options = SimpleItem.manage_options + ({'label':'Settings', 'action':'manage_settings'},)
                
    _properties = (
                { 'id':'host', 'type':'string', 'default':'localhost'},
                { 'id':'port', 'type':'int', 'default':1967},
                #{ 'id':'path_swap', 'type':'string', 'default':''},                   
                { 'id':'record_separator', 'type':'string', 'default':''}               
                )
    
    def __init__(self, id, title, host, port, path_swap=None, record_separator=' '):
        self.id = id
        self.title = title
        self.host = host
        self.port = port
        self.path_swap = path_swap
        self.record_separator = record_separator
        
    security.declareProtected('Use ExtSearch', 'search')
    def search(self, query, options=None):
        

        results = swish_search(host=self.host,
                      port=self.port,
                      query=query,
                      qoptions=options,
                      path_swap=self.path_swap,
                      )
        
        # not the most efficient way to do it...
        return map(ExtBrain, results, len(results)*[self.record_separator])
    
InitializeClass(ExtSearch)

class ExtBrain:
    
    __allow_access_to_unprotected_subobjects__ = 1
    
    def __init__(self, result, record_separator=' '):
        rank, self.path, size, self.title = split(result, record_separator,3)
        self.rank = atoi(rank)
        self.size = atoi(size)
        
    def __str__(self):
        """ """
        return """%s %s %s %s"""%(self.title,self.path, self.size, self.title)
        
    __repr__ = __str__
    __call__ = __str__
        
            
        
        
    
    
    
    
    



