# Author: Kapil Thangavelu <kvthan@wm.edu>
# License: GPL
# CVS: $Id $

import socket
from string import *

NotCommentLambda = lambda x: x[0]!='#'
    
def swish_search(host, port, query, qoptions={}, path_swap=None):
    """
    Connects to a Swish++ Search Daemon and executes query
    
    qoptions - contains possible search options to query
    pathswap - optional path alteration of returned paths
        pathswap is a tuple of original path, new path
    
    """
    sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    sock.connect((host,port))
    
    # query options not used yet
    buf = "search %s\n"%query
    
    while len(buf) > 0:
        scount = sock.send(buf)
        buf = buf[scount:]

    # out buf becomes in buf
    buf = ''

    while scount != 0:
        rbuf = sock.recv(8192)
        scount = len(rbuf)
        buf = '%s%s'%(buf,rbuf)

    ## hmm... this is a global search replace on a all results...
    if path_swap:
        buf = replace(buf, path_swap[0], path_swap[1])
    
    results = split(buf, '\n')
    
    ncl = NotCommentLambda
    results =filter(ncl, filter(None, results))
    return results


if __name__ == '__main__':
    import sys
    #print 'args'
    #print sys.argv
    if len(sys.argv) > 2: print 'usage SwishSearch searchphrase'
    r= swish_search('localhost', 1967, sys.argv[1])
    print str(r), type(r)

    
    
    
    
